//package explorer;

/**
 *
 * @author
 * @version
 */
import javax.swing.*;
import javax.swing.JTree.*;
import javax.swing.event.*;
import javax.swing.tree.*;
import javax.swing.tree.DefaultMutableTreeNode;
import java.io.*;
import java.io.File.*;
import java.lang.String.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;


public class NetExplorer extends javax.swing.JFrame {

    Properties props = new Properties();
    String execJava = "";
    boolean execJavaInvalid = false;

    private void loadProperties() {
        try {
            FileInputStream in = new FileInputStream("NetExplorer.props");
            props.load(in);
            in.close();
        }
        catch  (FileNotFoundException e) {}
        catch  (IOException e) {}
    }

    private void setProperties() {
        String x = props.getProperty("x","20");
        String y = props.getProperty("y","20");
        String w = props.getProperty("w","300");
        String h = props.getProperty("h","200");
        String d = props.getProperty("d","150");
	execJava = props.getProperty("execJava","/usr/local/sw/jdk/bin/java");

        this.setBounds(  Integer.parseInt(x) , Integer.parseInt(y)
                       , Integer.parseInt(w) , Integer.parseInt(h) );
        this.jSplitPane1.setDividerLocation(  Integer.parseInt(d) );
    }

    private void saveProperties() {
        Rectangle r = this.getBounds ();
        Object oldVal = new Object ();

        oldVal = props.setProperty("x", String.valueOf(r.x));
        oldVal = props.setProperty("y", String.valueOf(r.y));
        oldVal = props.setProperty("w", String.valueOf(r.width));
        oldVal = props.setProperty("h", String.valueOf(r.height));
        oldVal = props.setProperty("d", String.valueOf(this.jSplitPane1.getDividerLocation()));
	oldVal = props.setProperty("execJava", execJava);
	
        try {
            FileOutputStream out = new FileOutputStream("NetExplorer.props");
            props.store(out, "---NetExplorer.Props---");
            out.close();
        }
        catch (IOException e) {}
    }

    private void testExecJava() { 
	String inputval = execJava;
	do {
	   File f = new File(inputval);
	   if (!f.exists() | !f.isFile() | execJavaInvalid) {
		Object returnval = JOptionPane.showInputDialog(this,
			"Please input command for java (i.e. /usr/loacal/sw/jdk/bin/java",
			"NetExplorer",
			JOptionPane.QUESTION_MESSAGE,
			null,
			null,
			execJava);
			execJavaInvalid = false;
			if (returnval != null) {
			    inputval = (String)returnval;
			}
	   } else {
		break;
	   }
	} while (true);
	execJava = inputval;
    }
    

    /** Initializes the Form */
    public NetExplorer() {
	loadProperties();
        initComponents ();

        initStatusBar();
        initTree();
        pack ();

        //this.setLocation(100,100);
	setProperties ();
	//testExecJava();
    }

    public void initStatusBar() {
        progressBar = new JProgressBar(new DefaultBoundedRangeModel());
        progressBar.setMinimum(0);
        statusPanel.add(progressBar);
        statusLabel = new java.awt.Label ();
        statusLabel.setText ("");
        statusLabel.setName ("statusLabel");
        statusPanel.add (statusLabel);
    }

    public void initTree() {
        MyFile rootDir = new MyFile (System.getProperty("user.home"));
        final DefaultMutableTreeNode top = new DefaultMutableTreeNode(rootDir);
        jTree1 = new javax.swing.JTree (top);
        jTree1.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
        jTree1.putClientProperty("JTree.lineStyle", "Angled");

        jTree1.setCellRenderer(new MyRenderer());
        //Listen for when the selection changes.
        jTree1.addTreeSelectionListener(new TreeSelectionListener() {
            public void valueChanged(TreeSelectionEvent e) {
                DefaultMutableTreeNode node = (DefaultMutableTreeNode)
                                        jTree1.getLastSelectedPathComponent();
                 if (node == null) return;
                    // Object nodeInfo = node.getUserObject();
                     if (node.isLeaf()) {
                         buildtNextNodes(node);
                     }
                     final String path = node.toString();
                      if (path.endsWith(".net")){
                         showThumbnails((DefaultMutableTreeNode)node.getParent());
                         int i =  node.getParent().getIndex(node);
                            for (int o = 0; o < jPanel2.getComponentCount(); o++) {
                               Thumbnail jPane =(Thumbnail)jPanel2.getComponent(o);
                               if (o == i) {
                                 System.out.println(path+"  is  "+o+"-th component,and i is "+i);
                                  jPane.getComponent(0).setBackground(Color.white);
                               }
                                else {
                                     jPane.getComponent(0).setBackground(Color.lightGray);
                                }
                            }
                      }
                       else {
                         showThumbnails(node);
                      }

            }
         });


       jScrollPane2.setViewportView (jTree1);

    }


    public void showThumbnails(DefaultMutableTreeNode node) {
       // jPanel2 = new MyPanel();
        if (!node.equals(showNode)) {
              initPanel();
              showNode = node;
              System.out.println("showThumbnails start");
              int numOfPics = 0;
              progressBar.setMaximum(node.getChildCount()-1);
               for (int o = 0; o< node.getChildCount() ; o++) {
                  DefaultMutableTreeNode child = (DefaultMutableTreeNode)node.getChildAt(o);
                  MyFile f = (MyFile) child.getUserObject();
                     if (f.toString().endsWith(".net")) {
                       addThumbnail(f);
                       numOfPics++;
                     }

                  progressBar.setValue(o);
                  progressBar.paintImmediately(0,0,progressBar.getWidth(),progressBar.getHeight());
               }

            System.out.println("showThumbnails end");
            statusLabel.setText("Done");
	    jPanel2.recalculate();
	    jScrollPane1.revalidate();
	    jPanel2.revalidate();
            jPanel1.revalidate();
        }
    }


    public void  buildtNextNodes(DefaultMutableTreeNode parent) {

        DefaultMutableTreeNode child = null;
        MyFile parentFile = (MyFile)parent.getUserObject();

        if (parentFile.isDirectory()) {
              Vector dirList = new Vector(Arrays.asList(parentFile.list()));
              progressBar.setValue(0);
              statusLabel.setText("Reading Directory");
              System.out.println("DirList.length :"+ dirList.size());
              progressBar.setMaximum(dirList.size()-1);
              statusLabel.setSize(new Dimension(500,20));
               for (int i=0; i<dirList.size(); i++)  {
                  final MyFile f = new MyFile(parentFile.getAbsolutePath()+"/"+(String)dirList.get(i));

                   if ( (f.isDirectory() & f.canRead() & !(f.toString().startsWith(".")))
                      | (f.toString().endsWith(".net"))) {
                        child = new DefaultMutableTreeNode(f);
                        parent.add(child);
                   }

                  progressBar.setValue(i);
                  progressBar.paintImmediately(0,0,progressBar.getWidth(),progressBar.getHeight());

               }
             jPanel2.revalidate();
	     jPanel2.repaint();
        }
    }



    public void initPanel(){
	System.out.println("initPanel");
        jPanel2.removeAll();
        jPanel2.repaint();
    }

    public void addThumbnail(File f){
      statusLabel.setText("opening file's :  "+ f);
      Thumbnail jPane = new Thumbnail(f);
      jPane.setExecJava(execJava);
      jPanel2.add(jPane);
      //jPanel1.add (jPanel2, "Center");

    }



  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
  private void initComponents () {//GEN-BEGIN:initComponents
    addWindowListener (new java.awt.event.WindowAdapter () {
        public void windowClosing (java.awt.event.WindowEvent evt) {
          exitForm (evt);
        }
      }
    );
    getContentPane ().setLayout (new java.awt.BorderLayout ());

    menuBar = new javax.swing.JMenuBar ();
      fileMenu = new javax.swing.JMenu ();
      fileMenu.setText ("File");
      fileMenu.setName ("File");

        exitMenuItem = new javax.swing.JMenuItem ();
        exitMenuItem.setText ("Exit");
        exitMenuItem.addActionListener (new java.awt.event.ActionListener () {
            public void actionPerformed (java.awt.event.ActionEvent evt) {
              exitMenuItemActionPerformed (evt);
            }
          }
        );
        fileMenu.add(exitMenuItem);

      menuBar.add(fileMenu);

      editMenu = new javax.swing.JMenu ();
      editMenu.setText ("Edit");

        changeExecMenuItem = new javax.swing.JMenuItem ();
        changeExecMenuItem.setText ("Change Exec Command");
        changeExecMenuItem.addActionListener (new java.awt.event.ActionListener () {
            public void actionPerformed (java.awt.event.ActionEvent evt) {
              changeExecMenuItemActionPerformed (evt);
            }
          }
        );
        editMenu.add(changeExecMenuItem);

      menuBar.add(editMenu);

      helpMenu = new javax.swing.JMenu ();
      helpMenu.setText ("Help");
        contentsMenuItem = new javax.swing.JMenuItem ();
        contentsMenuItem.setText ("Contents");
        helpMenu.add(contentsMenuItem);

        helpMenu.addSeparator();

        aboutMenuItem = new javax.swing.JMenuItem ();
        aboutMenuItem.setText ("About");
        helpMenu.add(aboutMenuItem);

      menuBar.add(helpMenu);


    setJMenuBar(menuBar);
    jSplitPane1 = new javax.swing.JSplitPane ();
    jSplitPane1.setPreferredSize (new java.awt.Dimension(820, 525));
    jSplitPane1.setOneTouchExpandable (true);

      jScrollPane1 = new javax.swing.JScrollPane ();
      jScrollPane1.setPreferredSize (new java.awt.Dimension(700, 500));
      jScrollPane1.getHorizontalScrollBar().setBlockIncrement(90);
      jScrollPane1.getHorizontalScrollBar().setUnitIncrement(90);


        jPanel1 = new javax.swing.JPanel ();
        jPanel1.setLayout (new java.awt.FlowLayout(FlowLayout.LEFT));

	  jPanel2 = new MyPanel(jScrollPane1);
          jPanel2.setLayout (new java.awt.GridLayout (3, 5, 0, 0));

          jPanel1.add (jPanel2);//, "West");

      jScrollPane1.setViewportView (jPanel1);
      jSplitPane1.setRightComponent (jScrollPane1);

      jScrollPane2 = new javax.swing.JScrollPane ();
      jScrollPane2.setPreferredSize (new java.awt.Dimension(120, 3));
      jScrollPane2.setBackground (java.awt.Color.white);

      jSplitPane1.setLeftComponent (jScrollPane2);

    getContentPane ().add (jSplitPane1, "Center");

    statusPanel = new java.awt.Panel ();
    statusPanel.setName ("statusPanel");
    statusPanel.setLayout (new java.awt.FlowLayout (0, 5, 5));

    getContentPane ().add (statusPanel, "South");

  }//GEN-END:initComponents


  private void changeExecMenuItemActionPerformed (java.awt.event.ActionEvent evt) {
    // Add your handling code here:
     execJavaInvalid = true;
     testExecJava();
     for (int i=0; i < jPanel2.getComponentCount(); i++) {
	Thumbnail t = (Thumbnail)jPanel2.getComponent(i); 
	t.setExecJava(execJava);
     }
  }


  private void exitMenuItemActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitMenuItemActionPerformed
    saveProperties();
    System.exit (0);
  }//GEN-LAST:event_exitMenuItemActionPerformed

  /** Exit the Application */
  private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
    System.exit (0);
  }//GEN-LAST:event_exitForm


// Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JSplitPane jSplitPane1;
  private java.awt.Panel statusPanel;
  private javax.swing.JScrollPane jScrollPane1;
  private javax.swing.JScrollPane jScrollPane2;
  private javax.swing.JPanel jPanel1;
  //private javax.swing.JPanel jPanel2;
  private MyPanel jPanel2;
  private javax.swing.JMenuBar menuBar;
  private javax.swing.JMenu fileMenu;
  private javax.swing.JMenu editMenu;
  private javax.swing.JMenu helpMenu;
  private javax.swing.JMenuItem exitMenuItem;
  private javax.swing.JMenuItem changeExecMenuItem;
  private javax.swing.JMenuItem contentsMenuItem;
  private javax.swing.JMenuItem aboutMenuItem;
// End of variables declaration//GEN-END:variables
  private javax.swing.JTree jTree1;
  private java.awt.Label statusLabel;
  private javax.swing.JProgressBar progressBar;
  private DefaultMutableTreeNode showNode;

  public static void main(java.lang.String[] args) {
      NetExplorer n = new NetExplorer ();
	n.show();
        n.testExecJava();
  }
}


class MyFile extends File {
    public MyFile(String path) {
        super(path);
    }
    public String toString() {
        return super.getName();
    }
}


class Thumbnail extends JPanel{

    JButton button = new JButton();
    JLabel icon = null;
    ImageIcon gif = null;
    String fileName;
    int x;
    int y;

    String execJava;

    public void setExecJava(String s) {
	this.execJava = s;
    }
    public String getExecJava() {
	return this.execJava;
    }

    public void paintComponent(Graphics g){
        x=this.getWidth();
        y=this.getHeight();
        this.button.setBounds(5,5*(y/6),x-10,(y/6)-3);
        this.icon.setBounds(5,5,x-10,5*(y/6)-5);
        super.paintComponent(g);
    }

    public Thumbnail(final File f){
        button.setLabel(f.toString());
        button.setToolTipText(f.toString());
         button.addActionListener(new java.awt.event.ActionListener () {
            public void actionPerformed (java.awt.event.ActionEvent evt) {
             buttonActionPerformed (evt);
            }
    });
        this.setLayout(null);
        this.add(button);

        File parentFile = f.getParentFile();
        fileName = f.getAbsolutePath();
        Vector dirList = new Vector(Arrays.asList(parentFile.list()));
        String s = new String();
        s = f.toString().substring(0,((f.toString().length())-4));

        boolean found = false;
        for(int j=0;j<dirList.size();j++){
            MyFile g = new MyFile(parentFile.getAbsolutePath()+"/"+(String)dirList.get(j));

            if(g.toString().endsWith(".gif")){
                if(s.equals(g.toString().substring(0,(g.toString().length())-4))){
                    found = true;
                    // add gif
                    System.out.println("found gif: "+g.toString());
                    gif = new ImageIcon(parentFile.getAbsolutePath()+"/"+g.toString());
                    icon = new JLabel(gif);
                    this.add(icon);
                    break;
                }
            }
        }

       if (!found) {
        boolean error = false;
            System.out.println("no matching gif found");
            NetPanel netPane = new NetPanel();

            try {
                netPane.createThumbnailGif(f);
             }
              catch (FileNotFoundException e) {
                System.out.println("FileNotFoundException occured");
                error = true;
              }
                catch (IOException e) {
                 System.out.println("IOException occured");
                 error = true;
               }

         if (!error) {
             System.out.println("created thumbnail from "+f.toString());
                 gif = new ImageIcon(f.toString().substring(0,f.toString().length()-4)+".gif");
          }
           else {
              System.out.println("using default.gif");
              gif = new ImageIcon("/home/stud2/mjestrat/default.gif");
           }
            icon = new JLabel(gif);
            System.out.println("created thumbnail from "+f.toString());
        }
    }


    public void buttonActionPerformed(java.awt.event.ActionEvent evt) {
      System.out.println("/usr/local/sw/jdk/bin/java NetViewer "+fileName);
      try {
            Runtime.getRuntime().exec("touch toast1.txt");
            Runtime.getRuntime().exec(execJava+" NetViewer "+fileName);
      }
       catch (java.io.IOException e) {

            System.out.println("can't access command line :"+ e.toString());
       }
    }
}
class MyRenderer extends DefaultTreeCellRenderer {
       ImageIcon tutorialIcon;

       public MyRenderer() {
            tutorialIcon = new ImageIcon("middle.gif");
       }
        public Component getTreeCellRendererComponent(
                            JTree tree,
                            Object value,
                            boolean sel,
                            boolean expanded,
                            boolean leaf,
                            int row,
                            boolean hasFocus) {

            super.getTreeCellRendererComponent(
                            tree, value, sel,
                            expanded, leaf, row,
                            hasFocus);

            if(leaf && isFile(value)) {
                 setIcon(tutorialIcon);
            }else {
                 setIcon(closedIcon);
            }
            return this;
        }
        protected boolean isFile(Object value) {
            DefaultMutableTreeNode node = (DefaultMutableTreeNode)value;
            File f =(File)(node.getUserObject());
            return f.isFile();
        }
  }
class MyPanel extends JPanel{
  GridLayout grid;
  JScrollPane parent;
  boolean inval;
  public MyPanel(JScrollPane p) {
	parent = p;
  }

  public void recalculate() {
	this.inval= true;
  }
  public void paintComponent(Graphics g){
       int x=this.getWidth();
       int y=Math.max(parent.getHeight(),120);
	grid = (GridLayout)this.getLayout();
	int rows = grid.getRows();
	int newRows = y/120;
	System.out.println("repaint jPanel2");
	if ((rows != newRows) | inval) {
	    inval= false;
	    grid.setRows(newRows);
	    int compCount = this.getComponentCount();
	    int newCols = compCount/newRows ;
	    if (newCols * newRows < compCount) {
		System.out.println("increasing newCols ");
		newCols += 1;
	    }
	    grid.setColumns(newCols);

            this.setPreferredSize(new Dimension(newCols*90,newRows*120));
            this.setMinimumSize(new Dimension(newCols*90,newRows*120));
            this.setMaximumSize(new Dimension(newCols*90,newRows*120));

	    parent.revalidate();
	    parent.repaint();
	    this.revalidate();
	    this.repaint();
	    System.out.println("compCount "+compCount+"  Rows "+newRows+"  Cols"+newCols);
	}
        //System.out.println("MyPanel :"+x+"  "+y);
        super.paintComponent(g);
    }
} 
