//package toast;

import java.awt.*;
import java.util.*;
import java.io.*;
import java.awt.image.*;
/**
*
* @author
* @version
*/

public class NetPanel extends javax.swing.JPanel {
   // variables for the graphical things...
   private boolean isThumbnail;
   private Dimension thumbnailDimension;
   private NetObject netObject;
   private boolean validNet;
   private NetProperties netProperties = new NetProperties("NetProperties.props");
   private Color backgroundColor = new Color(0,0,0); 

   private String netFileName;

   //constructor:
   public NetPanel() {
       netObject = new NetObject();
       validNet = true;
       thumbnailDimension = new Dimension(80,80);
   }

   public void showPropDialog(int x, int y){
       netProperties.setLocation(new Point(x,y));
       netProperties.setState(Frame.NORMAL);
       netProperties.show();
   }

   public void createThumbnailGif (File f) throws IOException, FileNotFoundException  {
	//String fileName = f.toString();
	String fileName = f.getAbsolutePath();
	fileName = fileName.substring(0, fileName.length() -4)+".gif";
	
	
	//System.out.println("opening File "+fileName);
	FileOutputStream out = new  FileOutputStream(fileName);
	//System.out.println("creating bufferedImage");
	BufferedImage bimage = new BufferedImage(80,80,BufferedImage.TYPE_INT_RGB);
	//System.out.println("creating gifEncoder");
	GifEncoder gen = new GifEncoder(bimage, out);
	

	// hier malen auf g
	Graphics g = bimage.getGraphics();
	g.setColor(Color.white);
	g.fillRect(0,0,80,80);
	// SNNS-File laden:
	//System.out.println("reading SNNS-File");
	netObject.readSNNSFile(f);
	netObject.scaleTo(70,70);
	//netObject.setSize(80,80);
	netObject.paintThumbnail(g);
	
	//System.out.println("encoding to gif");	
	gen.encode();
	//System.out.println("closing File");
	out.close(); 

	
   }

   public int readFile(File f) {
      try {
        netObject.readSNNSFile(f);
      } catch (IOException e) {
        validNet = false;
        //log.append(netObject.toString());
        return -1;
      }
      //System.out.println(f.toString());
      netFileName = f.toString();
      netObject.readPropsFile(netFileName);

      validNet = true;
      //log.append(netObject.toString());
      repaint();
      repaint();

      return 0;

   }

   public void save() {
      netObject.save(netFileName);
   }


   public NetObject getModel () {
      return netObject;
   }

   // style of the drawings:
   public void setThumbnail( boolean tn ) {
      isThumbnail = tn;
   }

   public void setThumbnailDimension(int width, int height) {
      thumbnailDimension.setSize(width, height);
   }

   public String toString() {
       String s = netProperties.toString();
       s = s + netObject.toString();
       return s;
   }

   public boolean snapToGrid() {
       java.util.Properties props = new java.util.Properties();
       props = netProperties.getProperties();
       return props.getProperty("GridSnap").equals("true");
   }

   public int gridDist() {
       java.util.Properties props = new java.util.Properties(); 
       props = netProperties.getProperties();
       return Integer.parseInt(props.getProperty("GridDistance"));
   }
 
   // This method overides the original setBackground method.
   // it calls super.setBackground only if it's realy necessary, so it will avoid 
   // unneeded repaints of the Panel
   public void setBackground(Color c) { 
      if (!c.equals(backgroundColor)) {
	 backgroundColor = c;
         super.setBackground(backgroundColor);
      }
   }

   public void exportToPS (File f) {
	FileOutputStream out;
        Graphics g;
        PSGr psg;
        boolean error = false;

        try {
            out = new  FileOutputStream(f);
        } catch (FileNotFoundException e) {
            System.out.println("error while opening File " + e.toString());
	    return;
        } catch (IOException e) {
	    System.out.println("error while opening File " + e.toString());
            return;
	}		

        //System.out.println("generating outputstrem");
        g = this.getGraphics();

        Rectangle border = netObject.getBorder();



        psg = new PSGr(out, g, 30, 535, 782);
	psg.translate(0,-60);

	float sx = (float)535.0 / (float)(border.getWidth()+2*border.getX());
	float sy = (float)782.0 / (float)(border.getHeight()+2*border.getY());
	float factor = 0;

	factor = Math.min(sx,sy);

	psg.scale(factor,factor);
	psg.emitThis("1 setlinecap");
	psg.emitThis("1 setlinejoin");


        java.util.Properties props = new java.util.Properties();
        props = netProperties.getProperties();       
         
	paintGrid(psg, props);
        netObject.paintPS(psg, props); 

        try {
            out.close();
        } catch (IOException e) {}
        //System.out.println("Done");


   }	

   // this is the redrawing method, which shows the structure of the Net.
   public void paintComponent(Graphics g) {
       if (validNet) {
	   validNet = false;
           //System.out.println(" Start drawing NetObject");

           java.util.Properties props = new java.util.Properties();
           props = netProperties.getProperties();

           Rectangle border = netObject.getBorder();
           if (border != null) {
	       //int d = 40;
	       int d = gridDist();
	       if (border.x < (d-d/2) | border.x > (d + d/2) | border.y < (d-d/2) | border.y > (d + d/2)) {
                   //if (border.x != d | border.y != d) {
                   //System.out.println(" translocation: "+(d-border.x)+","+(d-border.y));
                   netObject.translate(d-border.x,d-border.y);
                   border.setLocation(d,d);
                   this.setPreferredSize (new java.awt.Dimension(border.width+80, border.height+80));
                   this.setMaximumSize (new java.awt.Dimension(border.width+80, border.height+80));
                   this.setMinimumSize (new java.awt.Dimension(border.width+80, border.height+80));
               }
           }


           // draw the background of the JPanel
           setBackground(new Color(Integer.parseInt(props.getProperty("BackGroundRed","204"))
                         ,Integer.parseInt(props.getProperty("BackGroundGreen","204"))
                         ,Integer.parseInt(props.getProperty("BackGroundBlue","204"))));
           super.paintComponent(g); //paint background
           // draw the Grid
           paintGrid(g, props);


           netObject.paintComponent(g, isThumbnail, props);
           //System.out.println(" Ended drawing NetObject");
	   validNet = true;
       } else {
	   //System.out.println(" Attempt to draw invalid Net"); 
       }
   }

   public void paintGrid(Graphics g, Properties props) {
      int step = Integer.parseInt(props.getProperty("GridDistance","10"));
      int sizeX = this.getWidth();
      int sizeY = this.getHeight();

      g.setColor(new Color(Integer.parseInt(props.getProperty("GridRed","204"))
                          ,Integer.parseInt(props.getProperty("GridGreen","204"))
                          ,Integer.parseInt(props.getProperty("GridBlue","204"))));

      if (props.getProperty("GridLayout").equals("1")) {
          for (int x = 0; x < sizeX; x=x+step){
              for (int y = 0; y < sizeY; y=y+step){
                  //g.drawRect(x,y,1,1);
		  g.drawLine(x,y,x,y);
              }
          }
      } else if (props.getProperty("GridLayout").equals("2")) {
          for (int x = 0; x < sizeX; x=x+step){
              g.drawLine(x,0,x,sizeY);
          }
          for (int y = 0; y < sizeY; y=y+step){
              g.drawLine(0,y,sizeX,y);
          }
      }

   }

}


