// package toast;

/**
 *
 * @author
 * @version
 */
import java.lang.*;
import java.io.*;
import javax.swing.*;
import java.awt.*;
import javax.swing.JScrollPane.*;
import java.util.Properties;

public class NetViewer extends javax.swing.JFrame implements Runnable {
  private static boolean startedFromMain = false;

  /**Create a file chooser */
  final JFileChooser fc = new JFileChooser();
  final MyFileFilter ff = new MyFileFilter(".net","SNNS Files");
  /** Filename for the Properties-File */
  private String PropertiesFileName;
  private Properties props = new Properties();
  private Unit lastHitUnit;
  private Unit lastFocusUnit; 
  private Point lastHitPoint;

  private UnitPropertiesJFrame unitProperties = new UnitPropertiesJFrame();

  /** Initializes the Form
   * Properties are loaded from String FileName*/
  public NetViewer(String PropertiesFileName) {
    fc.setFileFilter(ff);
    fc.addChoosableFileFilter(fc.getAcceptAllFileFilter());
    unitProperties.setVisible(false);
    this.PropertiesFileName = PropertiesFileName;
    initComponents ();
    initnet ();
    pack ();
    loadProperties();
    setProperties();
    initActionListeners();
  }

  private void initActionListeners() {
      unitProperties.getApplyButton().addActionListener (new java.awt.event.ActionListener () {
          public void actionPerformed (java.awt.event.ActionEvent evt) {
              //System.out.println("Apply pressed");
	      pastePropertiesToFocusUnits(evt);
/*	      if (lastFocusUnit != null) {
		 lastFocusUnit.setProperties(unitProperties.getProperties());
		 //System.out.println("Properties modified");
      		 netPane.repaint();
	      } */

          }
        }
      );

  }

  private void setProperties() {
    String x = props.getProperty("x","20");
    String y = props.getProperty("y","20");
    String w = props.getProperty("w","300");
    String h = props.getProperty("h","200");
    String d = props.getProperty("d","150");

    this.setBounds(  Integer.parseInt(x) , Integer.parseInt(y)
                   , Integer.parseInt(w) , Integer.parseInt(h) );
    this.splitPane.setDividerLocation(  Integer.parseInt(d) );
  }

  private void loadProperties() {
    try {
        FileInputStream in = new FileInputStream(PropertiesFileName);
        props.load(in);
        in.close();
    }
    catch  (FileNotFoundException e) {}
    catch  (IOException e) {}
  }

  /** save the Properties into a File
   */
  private void saveProperties() {
     Rectangle r = this.getBounds ();
     Object oldVal = new Object ();

     oldVal = props.setProperty("x", String.valueOf(r.x));
     oldVal = props.setProperty("y", String.valueOf(r.y));
     oldVal = props.setProperty("w", String.valueOf(r.width));
     oldVal = props.setProperty("h", String.valueOf(r.height));
     oldVal = props.setProperty("d", String.valueOf(this.splitPane.getDividerLocation()));


    try {
      FileOutputStream out = new FileOutputStream(PropertiesFileName);
      props.store(out, "---NetViewer.Props---");
      out.close();
    }
    catch (IOException e) {}
  }

  private void initnet() {
      netPane.setThumbnail( false );
      netPane.addMouseMotionListener (new javax.swing.event.MouseInputAdapter () {
          public void mouseDragged (java.awt.event.MouseEvent evt) {
              drawAreaMouseDragged (evt);
          }
	}
      );
      netPane.addMouseListener (new javax.swing.event.MouseInputAdapter () {
          public void mouseClicked (java.awt.event.MouseEvent evt) {
              drawAreaMouseClicked (evt);
          }
          public void mousePressed (java.awt.event.MouseEvent evt) {
	      drawAreaMousePressed (evt);
          }
          public void mouseReleased (java.awt.event.MouseEvent evt) {
	      drawAreaMouseReleased (evt);
          }
        }
      );
      topScrollPane.setViewportView (netPane);

  }


  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
  private void initComponents () {//GEN-BEGIN:initComponents
    addWindowListener (new java.awt.event.WindowAdapter () {
        public void windowClosing (java.awt.event.WindowEvent evt) {
          exitForm (evt);
        }
      }
    );
    getContentPane ().setLayout (new java.awt.GridLayout (1, 1));

    menuBar = new javax.swing.JMenuBar ();
      fileMenu = new javax.swing.JMenu ();
      fileMenu.setText ("File");
      fileMenu.setName ("File");
        openMenuItem = new javax.swing.JMenuItem ();
        openMenuItem.setText ("Open");
        openMenuItem.addActionListener (new java.awt.event.ActionListener () {
            public void actionPerformed (java.awt.event.ActionEvent evt) {
              openMenuItemActionPerformed (evt);
            }
          }
        );
        fileMenu.add(openMenuItem);

        saveMenuItem = new javax.swing.JMenuItem ();
        saveMenuItem.setText ("Save");
        saveMenuItem.addActionListener (new java.awt.event.ActionListener () {
            public void actionPerformed (java.awt.event.ActionEvent evt) {
              saveMenuItemActionPerformed (evt);
            }
          }
        );
        fileMenu.add(saveMenuItem);

        saveAsMenuItem = new javax.swing.JMenuItem ();
	saveAsMenuItem.setEnabled(false);
        saveAsMenuItem.setText ("Save As ...");
        fileMenu.add(saveAsMenuItem);

        fileMenu.addSeparator();

	exportMenuItem = new javax.swing.JMenuItem ();
        exportMenuItem.setText ("Export to PS");
	exportMenuItem.addActionListener (new java.awt.event.ActionListener () {
            public void actionPerformed (java.awt.event.ActionEvent evt) {
              exportMenuItemActionPerformed (evt);
            }
          }
        );
        fileMenu.add(exportMenuItem);

/*	gifMenuItem = new javax.swing.JMenuItem ();
        gifMenuItem.setText ("create Thumbnail");
        gifMenuItem.addActionListener (new java.awt.event.ActionListener () {
            public void actionPerformed (java.awt.event.ActionEvent evt) {
              gifMenuItemActionPerformed (evt);
            }
          }
        );
        fileMenu.add(gifMenuItem);
*/

        fileMenu.addSeparator();

        exitMenuItem = new javax.swing.JMenuItem ();
        exitMenuItem.setText ("Exit");
        exitMenuItem.addActionListener (new java.awt.event.ActionListener () {
            public void actionPerformed (java.awt.event.ActionEvent evt) {
              exitMenuItemActionPerformed (evt);
            }
          }
        );
        fileMenu.add(exitMenuItem);

      menuBar.add(fileMenu);

      editMenu = new javax.swing.JMenu ();
      editMenu.setText ("Edit");
        cutMenuItem = new javax.swing.JMenuItem ();
	cutMenuItem.setEnabled(false);
        cutMenuItem.setText ("Cut");
        cutMenuItem.addActionListener (new java.awt.event.ActionListener () {
            public void actionPerformed (java.awt.event.ActionEvent evt) {
              cutMenuItemActionPerformed (evt);
            }
          }
        );
        editMenu.add(cutMenuItem);

        copyMenuItem = new javax.swing.JMenuItem ();
	copyMenuItem.setEnabled(false);
        copyMenuItem.setText ("Copy");
        editMenu.add(copyMenuItem);

        pasteMenuItem = new javax.swing.JMenuItem ();
	pasteMenuItem.setEnabled(false);
        pasteMenuItem.setText ("Paste");
        editMenu.add(pasteMenuItem);

        editMenu.addSeparator();

        deleteMenuItem = new javax.swing.JMenuItem ();
	deleteMenuItem.setEnabled(false);
        deleteMenuItem.setText ("Delete");
        editMenu.add(deleteMenuItem);

      menuBar.add(editMenu);

      helpMenu = new javax.swing.JMenu ();
      helpMenu.setText ("Help");
        contentsMenuItem = new javax.swing.JMenuItem ();
	contentsMenuItem.setEnabled(false);
        contentsMenuItem.setText ("Contents");
        helpMenu.add(contentsMenuItem);

        helpMenu.addSeparator();

        aboutMenuItem = new javax.swing.JMenuItem ();
	aboutMenuItem.setEnabled(false);
        aboutMenuItem.setText ("About");
        helpMenu.add(aboutMenuItem);

      menuBar.add(helpMenu);


    popupMenu = new javax.swing.JPopupMenu ();
      PropertiesDrawAreaPopup = new javax.swing.JMenuItem ();
      PropertiesDrawAreaPopup.setText ("properties");
      PropertiesDrawAreaPopup.addActionListener (new java.awt.event.ActionListener () {
          public void actionPerformed (java.awt.event.ActionEvent evt) {
            PropertiesDrawAreaPopupActionPerformed (evt);
          }
        }
      );
      popupMenu.add(PropertiesDrawAreaPopup);

      MarkAllDrawAreaPopup = new javax.swing.JMenuItem ();
      MarkAllDrawAreaPopup.setText ("select all units");
      MarkAllDrawAreaPopup.addActionListener (new java.awt.event.ActionListener () {
          public void actionPerformed (java.awt.event.ActionEvent evt) {
            MarkAllDrawAreaPopupActionPerformed (evt);
          }
        }
      );
      popupMenu.add(MarkAllDrawAreaPopup);

      UnmarkAllDrawAreaPopup = new javax.swing.JMenuItem ();
      UnmarkAllDrawAreaPopup.setText ("unselect all units");
      UnmarkAllDrawAreaPopup.addActionListener (new java.awt.event.ActionListener () {
          public void actionPerformed (java.awt.event.ActionEvent evt) {
            UnmarkAllDrawAreaPopupActionPerformed (evt);
          }
	}
      );
      popupMenu.add(UnmarkAllDrawAreaPopup);

      InvertSelectionDrawAreaPopup = new javax.swing.JMenuItem ();
      InvertSelectionDrawAreaPopup.setText ("invert selection");
      InvertSelectionDrawAreaPopup.addActionListener (new java.awt.event.ActionListener () {
          public void actionPerformed (java.awt.event.ActionEvent evt) {
            InvertSelectionDrawAreaPopupActionPerformed (evt);
          }
        }
      );
      popupMenu.add(InvertSelectionDrawAreaPopup);

    popupMenuDatafield = new javax.swing.JPopupMenu ();
      showPropertiesUnitPopup = new javax.swing.JMenuItem ("show prop dialog");
      showPropertiesUnitPopup.addActionListener (new java.awt.event.ActionListener () {
          public void actionPerformed (java.awt.event.ActionEvent evt) {
            showPropertiesUnitPopupActionPerformed (evt);
          }
        }
      );
      popupMenuDatafield.add(showPropertiesUnitPopup);

      copyPropertiesUnitPopup = new javax.swing.JMenuItem ("copy properties");
      copyPropertiesUnitPopup.addActionListener (new java.awt.event.ActionListener () {
          public void actionPerformed (java.awt.event.ActionEvent evt) {
            copyPropertiesUnitPopupActionPerformed (evt);
          }
        }
      );
      popupMenuDatafield.add(copyPropertiesUnitPopup);
      pastePropertiesUnitPopup = new javax.swing.JMenuItem ("paste properties");
      pastePropertiesUnitPopup.addActionListener (new java.awt.event.ActionListener () {
          public void actionPerformed (java.awt.event.ActionEvent evt) {
            pastePropertiesUnitPopupActionPerformed (evt);
          }
        }
      );
      popupMenuDatafield.add(pastePropertiesUnitPopup);

      pastePropertiesToFocusUnitPopup = new javax.swing.JMenuItem ("paste properties to all focused");
      pastePropertiesToFocusUnitPopup.addActionListener (new java.awt.event.ActionListener () {
          public void actionPerformed (java.awt.event.ActionEvent evt) {
            pastePropertiesToFocusUnits (evt);
          }
        }
      );
      popupMenuDatafield.add(pastePropertiesToFocusUnitPopup);


      activateUnitPopup = new javax.swing.JMenuItem ("(de)activate");
      activateUnitPopup.addActionListener (new java.awt.event.ActionListener () {
          public void actionPerformed (java.awt.event.ActionEvent evt) {
           activateUnitPopupActionPerformed (evt);
          }
        }
      );
      popupMenuDatafield.add(activateUnitPopup); 
      //properties
      // activate/deactivat
      // show data
      // copy properties
      // paste properties

    setJMenuBar(menuBar);
    splitPane = new javax.swing.JSplitPane ();
    splitPane.setPreferredSize (new java.awt.Dimension(200, 150));
    splitPane.setOrientation (javax.swing.SwingConstants.HORIZONTAL);
    splitPane.setOneTouchExpandable (true);
    splitPane.setMinimumSize (new java.awt.Dimension(200, 150));

      topScrollPane = new javax.swing.JScrollPane ();
      topScrollPane.setPreferredSize (new java.awt.Dimension(200, 150));
      topScrollPane.setAutoscrolls (true);
      topScrollPane.setBackground (java.awt.Color.white);
      topScrollPane.setMinimumSize (new java.awt.Dimension(50, 50));

      splitPane.setTopComponent (topScrollPane);

      bottomScrollPane = new javax.swing.JScrollPane ();

        textArea = new javax.swing.JTextArea ();
        textArea.setMinimumSize (new java.awt.Dimension(50, 17));
        textArea.setEditable (false);

      bottomScrollPane.setViewportView (textArea);
      splitPane.setBottomComponent (bottomScrollPane);

    getContentPane ().add (splitPane);

  }//GEN-END:initComponents

  private void PropertiesDrawAreaPopupActionPerformed (java.awt.event.ActionEvent evt) {
    // Add your handling code here:
      netPane.showPropDialog(100,100);
      textArea.append(netPane.toString());
  }

  private void MarkAllDrawAreaPopupActionPerformed (java.awt.event.ActionEvent evt) {
    // Add your handling code here:
    for (int i = 0; i<netPane.getModel().getUnitCount(); i++) {
        netPane.getModel().getUnit(i).setFocus(true);
    } 
    netPane.repaint();
  }

  private void UnmarkAllDrawAreaPopupActionPerformed (java.awt.event.ActionEvent evt) {
    // Add your handling code here:
   for (int i = 0; i<netPane.getModel().getUnitCount(); i++) { 
        netPane.getModel().getUnit(i).setFocus(false);
    }   
    netPane.repaint(); 
  }

  private void InvertSelectionDrawAreaPopupActionPerformed (java.awt.event.ActionEvent evt) {
    // Add your handling code here:
   for (int i = 0; i<netPane.getModel().getUnitCount(); i++) {  
        netPane.getModel().getUnit(i).toggleFocus();
    }   
    netPane.repaint();
  }

  private void copyPropertiesUnitPopupActionPerformed (java.awt.event.ActionEvent evt) {
      // UNIT PROPERTIES
      Properties p = new Properties();
      p = lastFocusUnit.getProperties(p);
      unitProperties.setValuesToProperties(p);
      //unitProperties.setVisible(true);
  }

  private void showPropertiesUnitPopupActionPerformed (java.awt.event.ActionEvent evt) {
      Properties p = new Properties();
      p = lastFocusUnit.getProperties(p);
      unitProperties.setValuesToProperties(p);
      unitProperties.setVisible(true);
      netPane.repaint();
  }

  private void pastePropertiesUnitPopupActionPerformed (java.awt.event.ActionEvent evt) {
      lastFocusUnit.setProperties(unitProperties.getProperties());
      //System.out.println("Properties pasted");
      netPane.repaint();
  } 

  private void pastePropertiesToFocusUnits (java.awt.event.ActionEvent evt) {
      for (int i = 0; i<netPane.getModel().getUnitCount(); i++) {
	  if (netPane.getModel().getUnit(i).getFocus()) {
		netPane.getModel().getUnit(i).setProperties(unitProperties.getProperties());
	   }
      }
      netPane.repaint();
  }

  private void activateUnitPopupActionPerformed (java.awt.event.ActionEvent evt) {
      lastFocusUnit.toggleActivation();
      netPane.repaint();
  }

  private void saveMenuItemActionPerformed (java.awt.event.ActionEvent evt) {
    // Add your handling code here:

    netPane.save();

  }


//MOUSE HANDLER FOR DRAWING-AREA

  private void drawAreaMousePressed (java.awt.event.MouseEvent evt) {
      //System.out.println("Mouse Pressed. Pos:"+evt.getPoint().toString());
      NetObject netObject = netPane.getModel();
      boolean handled = false;

      Object hitObject = netObject.getObject(evt.getPoint());
      if (hitObject!=null) {
          //if (lastFocusUnit != null) lastFocusUnit.setFocus(false);
          lastFocusUnit = (Unit) hitObject;
          //lastFocusUnit.setFocus(true);
	  lastFocusUnit.toggleFocus();
	  unitProperties.setData(lastFocusUnit);
          lastHitPoint = evt.getPoint();
	  netPane.repaint();
      }

  }

  private void drawAreaMouseReleased (java.awt.event.MouseEvent evt) {
      //System.out.println("Mouse Released. Pos:"+evt.getPoint().toString());
      netPane.revalidate();	
      netPane.repaint();
      lastHitPoint = null;
  }
  private void drawAreaMouseDragged (java.awt.event.MouseEvent evt) {
      //System.out.println("Mouse Dragged. Pos:"+evt.getPoint().toString());
      if (lastHitPoint != null) {
	int x = (int)evt.getPoint().getX();
        int y = (int)evt.getPoint().getY();
	if (netPane.snapToGrid()) {
	     x = x + netPane.gridDist() / 2 ;
	     x = x / netPane.gridDist() ;
	     x = x * netPane.gridDist() ;
             y = y + netPane.gridDist() / 2 ;
             y = y / netPane.gridDist() ;
             y = y * netPane.gridDist() ;

	}

        //lastFocusUnit.customSetLocation((int)evt.getPoint().getX(),(int)evt.getPoint().getY());
	lastFocusUnit.customSetLocation( x , y );
        netPane.revalidate();
        netPane.repaint();
      }

  }

  private void drawAreaMouseClicked (java.awt.event.MouseEvent evt) {
      // Add your handling code here:
      // do research: where did you click ?
      NetObject netObject = netPane.getModel();
      boolean handled = false;

      Object hitObject = netObject.getObject(evt.getPoint());
      if (hitObject!=null) {
      
          //System.out.println("mouse clicked into Unit :\n"+hitObject.toString());
          if (evt.getClickCount() == 2) {
              popupMenuDatafield.show(evt.getComponent(), evt.getX(), evt.getY()); 
	  }
          handled = true;
      }

      // raise PopupMenu here, if mouse is on background....
      if (!handled) {
          popupMenu.show(evt.getComponent(), evt.getX(), evt.getY());
      }
  }

  private void openMenuItemActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_openMenuItemActionPerformed
    // Add your handling code here:
    int success;
    ff.setEnd(".net");
    ff.setDescription("SNNS Files");
    fc.rescanCurrentDirectory(); 
    int returnVal = fc.showOpenDialog(NetViewer.this);

    //System.out.println("OpenMenuItemActionPerformed Handler started");
    if (returnVal == JFileChooser.APPROVE_OPTION) {
        File file = fc.getSelectedFile();
        //this is where the application will open the file.
        //call the NetPane.setSNNSFile method for getting the Data out of it...
        // NetPane.setSNNSFile Returns 0 by success or -1 if failed.
        textArea.append("Opening: " + file.getName() + "\n");
        success = netPane.readFile(file);
        textArea.append(netPane.toString());
        if (success == 0) {
            textArea.append(" Done.\n");
        } else {
            textArea.append(" Failed. \n");
        }
    } else {
        textArea.append("Open command cancelled by user.\n");
    }

    //System.out.println("OpenMenuItemActionPerformed handled"); 
  }//GEN-LAST:event_openMenuItemActionPerformed

  private void cutMenuItemActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cutMenuItemActionPerformed
    // Add your handling code here:
  }//GEN-LAST:event_cutMenuItemActionPerformed

  private void exitMenuItemActionPerformed (java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitMenuItemActionPerformed
    saveProperties ();
    if (startedFromMain) {
        System.exit (0);
    } else {
        this.setVisible(false);
    }
  }//GEN-LAST:event_exitMenuItemActionPerformed

  /** Exit the Application */
  private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
    saveProperties ();
    if (startedFromMain) {
        System.exit (0);
    } else {
        this.setVisible(false);
    }
  }//GEN-LAST:event_exitForm


  private void exportMenuItemActionPerformed (java.awt.event.ActionEvent evt) {
	//System.out.println("preparing to exort PS-File");
	ff.setEnd(".ps");
        ff.setDescription("PostScript Files");
	fc.rescanCurrentDirectory();


// DIRTY HACK !!! CALL SUN TO IMPLEMENT THIS !!!!
	JPanel jp = (JPanel)fc.getComponent(5);
	JPanel j = (JPanel)jp.getComponent(3); 
	JComboBox cb = (JComboBox) j.getComponent(2);
	cb.setSelectedItem(ff);
// END OF DIRTY HACK

	int returnval = fc.showSaveDialog(NetViewer.this);
	System.out.println("FileChooser returned with "+returnval);
	if (returnval == 0) {
	    File f = fc.getSelectedFile();
	    if (f.exists() && f.getAbsolutePath().endsWith(".ps")) {
	        int answer = JOptionPane.showConfirmDialog(this,
						   "File "+f.getAbsolutePath()+" already exists. Overwrite ?",
						   "Export to PS", 
						   JOptionPane.YES_NO_OPTION);
	        if (answer == 0) {
		    System.out.println("exporting PS ...");
		    netPane.exportToPS(f);
	        }		
	    } else if (!f.getAbsolutePath().endsWith(".ps")) {
		File psFile = new File(f.getAbsolutePath()+".ps");
		JOptionPane.showMessageDialog(this, 
					      "File renamed, now writing to "+psFile.getAbsolutePath(),
					      "Export to PS", 
					      JOptionPane.INFORMATION_MESSAGE);
		if (psFile.exists()) {
		    int answer = JOptionPane.showConfirmDialog(this,
						       "File "+psFile.getAbsolutePath()+" already exists. Overwrite ?",
						       "Export to PS", 
						       JOptionPane.YES_NO_OPTION);
                    if (answer == 0) {
			System.out.println("exporting PS ...");
	                netPane.exportToPS(psFile);
                    }
	        } else {
		    System.out.println("exporting PS ...");
                    netPane.exportToPS(psFile);
		}
	    } else {
		System.out.println("exporting PS ...");
	        netPane.exportToPS(f);	
	    }
	
		 
	}
  }

  private void gifMenuItemActionPerformed (java.awt.event.ActionEvent evt) {
        //System.out.println("creating Gif-File");
	try {
	    File f = new File("output.gif"); 
	    netPane.createThumbnailGif (f);
	} 
	catch (FileNotFoundException e) {}
	catch (IOException e) {}
  }
	



// Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JSplitPane splitPane;
  private javax.swing.JScrollPane topScrollPane;
  private javax.swing.JScrollPane bottomScrollPane;
  private javax.swing.JTextArea textArea;
  private javax.swing.JMenuBar menuBar;
  private javax.swing.JPopupMenu popupMenu;
  private javax.swing.JPopupMenu popupMenuDatafield;
  private javax.swing.JMenu fileMenu;
  private javax.swing.JMenu editMenu;
  private javax.swing.JMenu helpMenu;
  private javax.swing.JMenuItem openMenuItem;
  private javax.swing.JMenuItem saveMenuItem;
  private javax.swing.JMenuItem saveAsMenuItem;
  private javax.swing.JMenuItem exitMenuItem;
  private javax.swing.JMenuItem exportMenuItem;
  private javax.swing.JMenuItem gifMenuItem;
  private javax.swing.JMenuItem cutMenuItem;
  private javax.swing.JMenuItem copyMenuItem;
  private javax.swing.JMenuItem pasteMenuItem;
  private javax.swing.JMenuItem deleteMenuItem;
  private javax.swing.JMenuItem contentsMenuItem;
  private javax.swing.JMenuItem aboutMenuItem;
  private javax.swing.JMenuItem PropertiesDrawAreaPopup;
  private javax.swing.JMenuItem MarkAllDrawAreaPopup;
  private javax.swing.JMenuItem UnmarkAllDrawAreaPopup;
  private javax.swing.JMenuItem InvertSelectionDrawAreaPopup;
  private javax.swing.JMenuItem activateUnitPopup;
  private javax.swing.JMenuItem copyPropertiesUnitPopup;
  private javax.swing.JMenuItem pastePropertiesUnitPopup;
  private javax.swing.JMenuItem pastePropertiesToFocusUnitPopup;
  private javax.swing.JMenuItem showPropertiesUnitPopup;

// End of variables declaration//GEN-END:variables
  public static NetPanel netPane = new NetPanel();



  public static void main(java.lang.String[] args) {
    new NetViewer ("NetViewer.Props").show ();
    startedFromMain = true;
    try {
        if (args[0] !=null) {
            File f = new File(args[0]);
            netPane.readFile(f);

/*	    try {
                netPane.createThumbnailGif (f);
            }
	    catch (FileNotFoundException e) {
                System.out.println("catched FileNotFoundException");
                }
            catch (IOException e) {
                System.out.println("catched IOExcetion");
            }
	    System.exit (0);
*/
        }
	
    }
    catch (ArrayIndexOutOfBoundsException e){
    }
  }

  public void run() {
      System.out.println("NetViewer: run() method called");
      //System.exit (0);
  }

}

